type t = int * string list

let create = (0, [])

let append (len, lst) str =
  (len + String.length str,
   str :: lst)

let from_string s = append create s

let to_string (_, lst) =
  List.fold_left
    (fun acc -> fun elm -> elm ^ acc)
    ""
    lst

let output chan (_, lst) =
  List.iter
    (fun s -> output_string chan s)
    (List.rev lst)

let length (len, _) = len

let concat strees =
  List.fold_left
    (fun (len1, st1) -> fun (len2, st2) ->
      (len1 + len2, st2 @ st1))
    create
    strees

let concat2 strees =
  List.fold_right
    (fun (len1, st1) -> fun (len2, st2) ->
      (len1 + len2, st2 @ st1))
    strees
    create
